//
//  TapViewController.swift
//  gestures
//
//  Created by Kyrill Schmid on 17.11.17.
//  Copyright © 2017 Kyrill Schmid. All rights reserved.
//

import UIKit

class DragAndDrop: UIViewController, UIGestureRecognizerDelegate {

    @IBOutlet var panGR: UIPanGestureRecognizer!
    @IBOutlet var longPressGR: UILongPressGestureRecognizer!
    override func viewDidLoad() {
        super.viewDidLoad()        // Do any additional setup after loading the view, typically from a nib.

    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func gestureRecognizer(_ gestureRecognizer: UIGestureRecognizer, shouldRecognizeSimultaneouslyWith otherGestureRecognizer: UIGestureRecognizer) -> Bool {
        return true
    }
    
    @IBAction func longPress(_ sender: UILongPressGestureRecognizer) {
        if sender.state == UIGestureRecognizerState.began  || sender.state == UIGestureRecognizerState.changed {
            if let view = sender.view {
                view.alpha = 0.5
            }
        } else {
            if let view = sender.view {
                view.alpha = 1.0
            }
        }
    }
    
    @IBAction func pan(_ sender: UIPanGestureRecognizer) {
        if self.longPressGR.state == .began || self.longPressGR.state == .changed {
            if let view = sender.view {
                view.center = sender.location(in: self.view)
            }
        }
    }
    
    
}
